Index: src/Actions/SelectionAction/AllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllMoleculesAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllMoleculesAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -2,5 +2,5 @@
  * AllMoleculesAction.hpp
  *
- *  Created on: May 12, 2010
+ *  Created on: Aug 09, 2010
  *      Author: heber
  */
@@ -9,29 +9,9 @@
 #define ALLMOLECULESSACTION_HPP_
 
+
 #include "Actions/Action.hpp"
 
-void SelectionAllMolecules();
-
-class SelectionAllMoleculesAction : public Action {
-  friend void SelectionAllMolecules();
-
-public:
-  SelectionAllMoleculesAction();
-  virtual ~SelectionAllMoleculesAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AllMoleculesAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ALLMOLECULESSACTION_HPP_ */
Index: src/Actions/SelectionAction/AtomByElementAction.cpp
===================================================================
--- src/Actions/SelectionAction/AtomByElementAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AtomByElementAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AtomByElementAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomTypeDescriptor.hpp"
 #include "atom.hpp"
@@ -34,55 +32,19 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AtomByElementAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionAtomByElementState : public ActionState {
-public:
-  SelectionAtomByElementState(std::vector<atom*> _selectedAtoms, const element *_elemental) :
-    selectedAtoms(_selectedAtoms),
-    elemental(_elemental)
-  {}
-  std::vector<atom*> selectedAtoms;
-  const element *elemental;
-};
-
-const char SelectionAtomByElementAction::NAME[] = "select-atom-by-element";
-
-SelectionAtomByElementAction::SelectionAtomByElementAction() :
-  Action(NAME)
-{}
-
-SelectionAtomByElementAction::~SelectionAtomByElementAction()
-{}
-
-void SelectionAtomByElement(const element &_element) {
-  ValueStorage::getInstance().setCurrentValue(SelectionAtomByElementAction::NAME, _element);
-  ActionRegistry::getInstance().getActionByName(SelectionAtomByElementAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAtomByElementAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionAtomByElementAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryElement(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "AtomByElementAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionAtomByElementAction::performCall() {
-  const element *elemental;
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Selecting atoms of type " << *elemental << endl);
-  World::getInstance().selectAllAtoms(AtomByType(elemental));
-  return Action::state_ptr(new SelectionAtomByElementState(selectedAtoms,elemental));
+  DoLog(1) && (Log() << Verbose(1) << "Selecting atoms of type " << *params.elemental << endl);
+  World::getInstance().selectAllAtoms(AtomByType(params.elemental));
+  return Action::state_ptr(new SelectionAtomByElementState(selectedAtoms,params));
 }
 
@@ -100,5 +62,5 @@
   SelectionAtomByElementState *state = assert_cast<SelectionAtomByElementState*>(_state.get());
 
-  World::getInstance().selectAllAtoms(AtomByType(state->elemental));
+  World::getInstance().selectAllAtoms(AtomByType(state->params.elemental));
 
   return Action::state_ptr(_state);
@@ -116,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AtomByElementAction.def
===================================================================
--- src/Actions/SelectionAction/AtomByElementAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/AtomByElementAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * AtomByElementAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class element;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (const element*)
+#define paramtokens (SelectionAtomByElementAction::NAME)
+#define paramreferences (elemental)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AtomByElement
+#define TOKEN "select-atom-by-element"
+
Index: src/Actions/SelectionAction/AtomByElementAction.hpp
===================================================================
--- src/Actions/SelectionAction/AtomByElementAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AtomByElementAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class element;
-
-void SelectionAtomByElement(const element &_element);
-
-class SelectionAtomByElementAction : public Action {
-  friend void SelectionAtomByElement(const element &_element);
-
-public:
-  SelectionAtomByElementAction();
-  virtual ~SelectionAtomByElementAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AtomByElementAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ATOMBYELEMENTACTION_HPP_ */
Index: src/Actions/SelectionAction/AtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/AtomByIdAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AtomByIdAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AtomByIdAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "Helpers/Log.hpp"
@@ -32,53 +30,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AtomByIdAction.hpp"
 
+// and construct the stuff
+#include "AtomByIdAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionAtomByIdAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionAtomByIdState : public ActionState {
-public:
-  SelectionAtomByIdState(atom* _walker) :
-    walker(_walker)
-  {}
-  atom* walker;
-};
-
-const char SelectionAtomByIdAction::NAME[] = "select-atom-by-id";
-
-SelectionAtomByIdAction::SelectionAtomByIdAction() :
-  Action(NAME)
-{}
-
-SelectionAtomByIdAction::~SelectionAtomByIdAction()
-{}
-
-void SelectionAtomById(atom *_atom) {
-  ValueStorage::getInstance().setCurrentValue(SelectionAtomByIdAction::NAME, _atom);
-  ActionRegistry::getInstance().getActionByName(SelectionAtomByIdAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAtomByIdAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionAtomByIdAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryAtom(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionAtomByIdAction::performCall() {
-  atom *Walker = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, Walker);
-
-  if (!World::getInstance().isSelected(Walker)) {
-    DoLog(1) && (Log() << Verbose(1) << "Selecting atom " << *Walker << endl);
-    World::getInstance().selectAtom(Walker);
-    return Action::state_ptr(new SelectionAtomByIdState(Walker));
+  if (!World::getInstance().isSelected(params.Walker)) {
+    DoLog(1) && (Log() << Verbose(1) << "Selecting atom " << *params.Walker << endl);
+    World::getInstance().selectAtom(params.Walker);
+    return Action::state_ptr(new SelectionAtomByIdState(params));
   } else {
     return Action::success;
@@ -89,8 +52,8 @@
   SelectionAtomByIdState *state = assert_cast<SelectionAtomByIdState*>(_state.get());
 
-  if (state->walker != NULL)
-    World::getInstance().unselectAtom(state->walker);
+  if (state->params.Walker != NULL)
+    World::getInstance().unselectAtom(state->params.Walker);
 
-  return Action::state_ptr(new SelectionAtomByIdState(state->walker));
+  return Action::state_ptr(_state);
 }
 
@@ -98,8 +61,8 @@
   SelectionAtomByIdState *state = assert_cast<SelectionAtomByIdState*>(_state.get());
 
-  if (state->walker != NULL)
-    World::getInstance().selectAtom(state->walker);
+  if (state->params.Walker != NULL)
+    World::getInstance().selectAtom(state->params.Walker);
 
-  return Action::state_ptr(new SelectionAtomByIdState(state->walker));
+  return Action::state_ptr(_state);
 }
 
@@ -115,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AtomByIdAction.def
===================================================================
--- src/Actions/SelectionAction/AtomByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/AtomByIdAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * AtomByIdAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class atom;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (atom*)
+#define paramtokens (SelectionAtomByIdAction::NAME)
+#define paramreferences (Walker)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AtomById
+#define TOKEN "select-atom-by-id"
+
Index: src/Actions/SelectionAction/AtomByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/AtomByIdAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AtomByIdAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class atom;
-
-void SelectionAtomById(atom *_atom);
-
-class SelectionAtomByIdAction : public Action {
-  friend void SelectionAtomById(atom *_atom);
-
-public:
-  SelectionAtomByIdAction();
-  virtual ~SelectionAtomByIdAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AtomByIdAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ATOMBYIDACTION_HPP_ */
Index: src/Actions/SelectionAction/ClearAllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/ClearAllAtomsAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/ClearAllAtomsAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/ClearAllAtomsAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
@@ -33,48 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/ClearAllAtomsAction.hpp"
 
+// and construct the stuff
+#include "ClearAllAtomsAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionClearAllAtomsAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionClearAllAtomsState : public ActionState {
-public:
-  SelectionClearAllAtomsState(std::vector<atom*> _selectedAtoms) :
-    selectedAtoms(_selectedAtoms)
-  {}
-  std::vector<atom*> selectedAtoms;
-};
-
-const char SelectionClearAllAtomsAction::NAME[] = "clear-atom-selection";
-
-SelectionClearAllAtomsAction::SelectionClearAllAtomsAction() :
-  Action(NAME)
-{}
-
-SelectionClearAllAtomsAction::~SelectionClearAllAtomsAction()
-{}
-
-void SelectionClearAllAtoms() {
-  ActionRegistry::getInstance().getActionByName(SelectionClearAllAtomsAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionClearAllAtomsAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionClearAllAtomsAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionClearAllAtomsAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
   DoLog(1) && (Log() << Verbose(1) << "Clearing atoms selection." << endl);
   World::getInstance().clearAtomSelection();
-  return Action::state_ptr(new SelectionClearAllAtomsState(selectedAtoms));
+  return Action::state_ptr(new SelectionClearAllAtomsState(selectedAtoms, params));
 }
 
@@ -86,13 +54,13 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionClearAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionClearAllAtomsAction::performRedo(Action::state_ptr _state){
-  SelectionClearAllAtomsState *state = assert_cast<SelectionClearAllAtomsState*>(_state.get());
+  //SelectionClearAllAtomsState *state = assert_cast<SelectionClearAllAtomsState*>(_state.get());
 
   World::getInstance().clearAtomSelection();
 
-  return Action::state_ptr(new SelectionClearAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
@@ -108,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/ClearAllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/ClearAllAtomsAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/ClearAllAtomsAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,24 @@
+/*
+ * ClearAllAtomsAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME ClearAllAtoms
+#define TOKEN "clear-atom-selection"
+
Index: src/Actions/SelectionAction/ClearAllAtomsAction.hpp
===================================================================
--- src/Actions/SelectionAction/ClearAllAtomsAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/ClearAllAtomsAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionAllAtoms();
-
-class SelectionClearAllAtomsAction : public Action {
-  friend void SelectionClearAllAtoms();
-
-public:
-  SelectionClearAllAtomsAction();
-  virtual ~SelectionClearAllAtomsAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "ClearAllAtomsAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* CLEARALLATOMSACTION_HPP_ */
Index: src/Actions/SelectionAction/ClearAllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/ClearAllMoleculesAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/ClearAllMoleculesAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/ClearAllMoleculesAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "atom.hpp"
@@ -33,48 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/ClearAllMoleculesAction.hpp"
 
+// and construct the stuff
+#include "ClearAllMoleculesAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionClearAllMoleculesAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionClearAllMoleculesState : public ActionState {
-public:
-  SelectionClearAllMoleculesState(std::vector<molecule*> selectedMolecules) :
-    selectedMolecules(selectedMolecules)
-  {}
-  std::vector<molecule*> selectedMolecules;
-};
-
-const char SelectionClearAllMoleculesAction::NAME[] = "clear-molecule-selection";
-
-SelectionClearAllMoleculesAction::SelectionClearAllMoleculesAction() :
-  Action(NAME)
-{}
-
-SelectionClearAllMoleculesAction::~SelectionClearAllMoleculesAction()
-{}
-
-void SelectionClearAllMolecules() {
-  ActionRegistry::getInstance().getActionByName(SelectionClearAllMoleculesAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionClearAllMoleculesAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionClearAllMoleculesAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionClearAllMoleculesAction::performCall() {
   std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
   DoLog(1) && (Log() << Verbose(1) << "Clearing molecule selection." << endl);
   World::getInstance().clearMoleculeSelection();
-  return Action::state_ptr(new SelectionClearAllMoleculesState(selectedMolecules));
+  return Action::state_ptr(new SelectionClearAllMoleculesState(selectedMolecules,params));
 }
 
@@ -86,13 +54,13 @@
     World::getInstance().selectMolecule(*iter);
 
-  return Action::state_ptr(new SelectionClearAllMoleculesState(state->selectedMolecules));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionClearAllMoleculesAction::performRedo(Action::state_ptr _state){
-  SelectionClearAllMoleculesState *state = assert_cast<SelectionClearAllMoleculesState*>(_state.get());
+  //SelectionClearAllMoleculesState *state = assert_cast<SelectionClearAllMoleculesState*>(_state.get());
 
   World::getInstance().clearMoleculeSelection();
 
-  return Action::state_ptr(new SelectionClearAllMoleculesState(state->selectedMolecules));
+  return Action::state_ptr(_state);
 }
 
@@ -108,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/ClearAllMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/ClearAllMoleculesAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/ClearAllMoleculesAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,24 @@
+/*
+ * ClearAllMoleculesAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME ClearAllMolecules
+#define TOKEN "clear-molecule-selection"
+
Index: src/Actions/SelectionAction/ClearAllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/ClearAllMoleculesAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/ClearAllMoleculesAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionClearAllMolecules();
-
-class SelectionClearAllMoleculesAction : public Action {
-  friend void SelectionClearAllMolecules();
-
-public:
-  SelectionClearAllMoleculesAction();
-  virtual ~SelectionClearAllMoleculesAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "ClearAllMoleculesAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* CLEARALLMOLECULESSACTION_HPP_ */
Index: src/Actions/SelectionAction/MoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByFormulaAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/MoleculeByFormulaAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/MoleculeByFormulaAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeFormulaDescriptor.hpp"
 #include "molecule.hpp"
@@ -33,59 +31,23 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/MoleculeByFormulaAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionMoleculeByFormulaState : public ActionState {
-public:
-  SelectionMoleculeByFormulaState(std::vector<molecule*> selectedMolecules, const std::string &_formula) :
-    selectedMolecules(selectedMolecules),
-    formula(_formula)
-  {}
-  std::vector<molecule*> selectedMolecules;
-  std::string formula;
-};
-
-const char SelectionMoleculeByFormulaAction::NAME[] = "select-molecule-by-formula";
-
-SelectionMoleculeByFormulaAction::SelectionMoleculeByFormulaAction() :
-  Action(NAME)
-{}
-
-SelectionMoleculeByFormulaAction::~SelectionMoleculeByFormulaAction()
-{}
-
-void SelectionMoleculeByFormula(const std::string &_formula) {
-  ValueStorage::getInstance().setCurrentValue(SelectionMoleculeByFormulaAction::NAME, _formula);
-  ActionRegistry::getInstance().getActionByName(SelectionMoleculeByFormulaAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionMoleculeByFormulaAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionMoleculeByFormulaAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "MoleculeByFormulaAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionMoleculeByFormulaAction::performCall() {
-  std::string formula;
   std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, formula);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Selecting molecules with chemical formula " << formula << ":" << endl);
-  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(formula));
+  DoLog(1) && (Log() << Verbose(1) << "Selecting molecules with chemical formula " << params.formula << ":" << endl);
+  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula));
   for (std::vector<molecule *>::const_iterator iter = matchingMolecules.begin(); iter != matchingMolecules.end(); ++iter) {
     DoLog(1) && (Log() << Verbose(1) << "\t" << (*iter)->getId() << ", " << (*iter)->getName() << "." << endl);
   }
-  World::getInstance().selectAllMolecules(MoleculeByFormula(formula));
-  return Action::state_ptr(new SelectionMoleculeByFormulaState(selectedMolecules,formula));
+  World::getInstance().selectAllMolecules(MoleculeByFormula(params.formula));
+  return Action::state_ptr(new SelectionMoleculeByFormulaState(selectedMolecules,params));
 }
 
@@ -103,5 +65,5 @@
   SelectionMoleculeByFormulaState *state = assert_cast<SelectionMoleculeByFormulaState*>(_state.get());
 
-  World::getInstance().selectAllMolecules(MoleculeByFormula(state->formula));
+  World::getInstance().selectAllMolecules(MoleculeByFormula(state->params.formula));
 
   return Action::state_ptr(_state);
@@ -119,2 +81,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/MoleculeByFormulaAction.def
===================================================================
--- src/Actions/SelectionAction/MoleculeByFormulaAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/MoleculeByFormulaAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * MoleculeByFormulaAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (SelectionMoleculeByFormulaAction::NAME)
+#define paramreferences (formula)
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME MoleculeByFormula
+#define TOKEN "select-molecule-by-formula"
+
Index: src/Actions/SelectionAction/MoleculeByFormulaAction.hpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByFormulaAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/MoleculeByFormulaAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class molecule;
-
-void SelectionMoleculeByFormula(molecule *_mol);
-
-class SelectionMoleculeByFormulaAction : public Action {
-  friend void SelectionMoleculeByFormula(const std::string &_formula);
-
-public:
-  SelectionMoleculeByFormulaAction();
-  virtual ~SelectionMoleculeByFormulaAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "MoleculeByFormulaAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* MOLECULEBYFORMULAACTION_HPP_ */
